# ERV Samples

Ziel dieses Projektes ist es die Verwendung bzw. den Aufruf der ERV-Webserviceschnittstelle prägnant darzustellen damit ein schneller Einstieg in die
ERV-Integration erfolgen kann. Somit sind alle Code-Beispiele auf das Wesentliche reduziert, die Erstellung des Requests, der Aufruf und die Response-Behandlung 
sind umgesetzt, restlicher Code wie z.B. die Einbindung vom Client-Zertifikat sind nicht implementiert.

# Voraussetzungen

Um die Beispiele zu kompilieren und ausführen zu können werden nachfolgende Tools benötigt:

* Java SE Development Kit 8
* Apache Maven 3

# Aufbau und Verwendung

Das Projekt svk-erv-samples enthält mehrere Maven-Module:
* common
* nachricht_nachweis
* anschriftcode
* anschriftcode_kopplung



### common

Dieses Modul enthält Code der von allen anderen Maven-Modulen verwendet werden kann, z.B. die Erstellung einer ERV-Nachricht wird hier in einer Utility-Klasse 
zur Verfügung gestellt. Generierte Schemaklassen sind ebenfalls in diesem Modul hinterlegt.

### nachricht_nachweis

Dieses Modul enthält Beispiel-Code für die Verwendung der Nachricht-Nachweis-Schnittstelle. Damit sind Anwendungsfälle wie Nachrichten in den ERV einbringen od.
Nachrichten vom ERV abholen, umgesetzt. Die Klassenamen entsprechen in der Regel den WS-Operationen damit eine schnelle Zuordnung der Code-Beispiele erfolgen kann.
Es gibt nicht zwingend für jede WS-Operation eine eigene Klasse die die Verwendung demonstriert, manchmal kann es sinnvoll sein
mehrere WS-Operationen in Kombination zu verwenden wie z.B. bei der Abholung von Nachrichten, daher sind in der Klasse NachrichtAbholen
mehrere WS-Operationen in Kombination umgesetzt (NachrichtAnzahl, NachrichtAbholen, NachrichtBestaetigen).

### anschriftcode

In diesem Modul wird die Verwendung der Anschriftcode-Schnittstelle demonstriert.  
Anwendungsfälle wie den Status eines Anschriftcodes ändern, werden in diesem Modul demonstriert.
Die Klassennamen entsprechen den WS-Operationen damit eine schnelle Zuordnung der Code-Beispiele erfolgen kann.


### anschriftcode_kopplung

In diese Modul wird die Verwendung der Anschriftcode-Kopplung-Schnittstelle demonstriert.
Anwendungsfälle wie das Koppeln/Entkoppeln von einem Anschriftcode sowie die Abfrage dieser Information werden in diesem Modul demonstriert.
Die Klassennamen entsprechen den WS-Operationen damit eine schnelle Zuordnung der Code-Beispiele erfolgen kann.


Die Bespiele im Modul nachricht_nachweis, anschriftcode und anschriftcode_kopplung sind als Main-Klassen umgesetzt. Bei der Ausführung der Code-Beispiele
wird soweit möglich der jeweilige Request und der entsprechende Response in die Standardausgabe (System.out) geschrieben.