package at.gv.brz.bjujq.erv.samples.common;

import javax.activation.DataSource;
import java.io.*;

public class ByteArrayDataSource implements DataSource {

    private byte[] buffer;
    private String contentType;
    private String name;

    public ByteArrayDataSource(final byte[] content, final String name, final String contentType) {
        this.buffer = content;
        this.name = name;
        this.contentType = contentType;
    }

    @Override
    public InputStream getInputStream() throws IOException {
        return new ByteArrayInputStream(this.buffer);
    }

    @Override
    public OutputStream getOutputStream() throws IOException {
        throw new UnsupportedOperationException();
    }

    @Override
    public String getContentType() {
        return this.contentType;
    }

    @Override
    public String getName() {
        return this.name;
    }
}
