package at.gv.brz.bjujq.erv.samples.nachricht_nachweis;

import at.gv.brz.bjujq.erv.samples.common.ERVUtil;
import at.gv.brz.bjujq.erv.samples.common.MockErvNachrichtPortBuilder;
import at.gv.brz.bjujq.erv.samples.common.SchemaUtil;
import at.gv.justiz.erv.ervnachrichtextern.v3_0.ERVNachrichtTyp;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.ERVException_Exception;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.ERVNachrichtPortType;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.NachweisAbholenRequest;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.NachweisAbholenResponse;


public class NachweisAbholen {

    public static void main(String[] args) throws ERVException_Exception {
        ERVNachrichtPortType ervNachrichtPortType = new MockErvNachrichtPortBuilder()
                                        .withNachweisAbholen("RXXXXXX", "VJ")
                                        .build();

        // ERV-ID einer zuvor eingebrachten Nachricht
        final String nachrichtId = ERVUtil.generateRandomId();
        NachweisAbholenRequest request = SchemaUtil.OF_SERVICE.createNachweisAbholenRequest();
        request.setNachrichtenkennung(SchemaUtil.OF_NR.createNachrichtenkennungTyp());
        request.getNachrichtenkennung().setNachrichtId(nachrichtId);

        NachweisAbholenResponse response = ervNachrichtPortType.nachweisAbholen(request);

        // Fehlercodes siehe ERV-Publikation
        if (response.getFehler() != null) {
            if ("ERV_0039".equals(response.getFehler().getFehlercode())) {
                // Kein Nachweis vorhanden, spaeter nochmal abfragen
            }
        } else {
            ERVNachrichtTyp ervNachricht = response.getERVNachricht();

        }
    }
}
