package at.gv.brz.bjujq.erv.samples.nachricht_nachweis;

import at.gv.brz.bjujq.erv.samples.common.ERVUtil;
import at.gv.brz.bjujq.erv.samples.common.MockErvNachrichtPortBuilder;
import at.gv.brz.bjujq.erv.samples.common.SchemaUtil;
import at.gv.justiz.erv.ervnachrichtextern.v3_0.ERVNachrichtTyp;
import at.gv.justiz.erv.ervnachrichtextern.v3_0.StatusTyp;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.ERVException_Exception;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.ERVNachrichtPortType;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.NachweisEinbringenRequest;
import at.gv.justiz.erv.ervnachrichtserviceextern.v3_0.NachweisEinbringenResponse;


public class NachweisEinbringen {

    public static void main(String[] args) throws ERVException_Exception {
        ERVNachrichtPortType ervNachrichtPortType = new MockErvNachrichtPortBuilder()
                                        .withNachweisEinbringen()
                                        .build();

        // ERV-ID einer zuvor abgeholten und bestaetigten ERV-Nachricht, in diesem Beispiel erstellen wir der einfachheitshalber eine beliebige ID
        final String nachrichtId = ERVUtil.generateRandomId();
        ERVNachrichtTyp ervNachrichtTyp = SchemaUtil.createErvNachweisToJustizAT("RXXXXXX", "VJ", nachrichtId);
        NachweisEinbringenRequest request = SchemaUtil.OF_SERVICE.createNachweisEinbringenRequest();
        request.setERVNachricht(ervNachrichtTyp);

        NachweisEinbringenResponse response = ervNachrichtPortType.nachweisEinbringen(request);

        // Fehlercodes siehe ERV-Publikation
        if (response.getFehler() != null) {

        } else {
            StatusTyp statusTyp = response.getNachrichtstatus();
            // Der eingebrachte Nachweis befindet sich im Status HINTERLEGT
        }
    }
}
